## libaws 17.2.2017

=== Makefile ===
############################################################################
#                              Ada Web Server                              #
#                                                                          #
#                     Copyright (C) 2003-2016, AdaCore                     #
#                                                                          #
#  This is free software;  you can redistribute it  and/or modify it       #
#  under terms of the  GNU General Public License as published  by the     #
#  Free Software  Foundation;  either version 3,  or (at your option) any  #
#  later version.  This software is distributed in the hope  that it will  #
#  be useful, but WITHOUT ANY WARRANTY;  without even the implied warranty #
#  of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU     #
#  General Public License for  more details.                               #
#                                                                          #
#  You should have  received  a copy of the GNU General  Public  License   #
#  distributed  with  this  software;   see  file COPYING3.  If not, go    #
#  to http://www.gnu.org/licenses for a complete copy of the license.      #
############################################################################

.SILENT:

BROOTDIR=.build

#  NOTE: You should not have to change this makefile. Configuration options
#  can be changed in makefile.conf

include makefile.conf
#  default setup

include makefile.checks
#  consistency checks

ifeq (${PRJ_TARGET}, Windows_NT)
EXEEXT	= .exe
OS      = Windows_NT
else
ifeq ($(PRJ_TARGET), Darwin)
OS      = Darwin
else
OS      = UNIX
endif
EXEEXT	=
endif

ifeq ($(DEBUG), true)
MAKE_OPT	=
BDIR		= $(BROOTDIR)/$(TARGET)/debug
else
MAKE_OPT	= -s
BDIR		= $(BROOTDIR)/$(TARGET)/release
endif

#############################################################################
#  NO NEED TO CHANGE ANYTHING PAST THIS POINT
#############################################################################

all: build

ALL_OPTIONS	= $(MAKE_OPT) SOCKET="$(SOCKET)" XMLADA="$(XMLADA)" \
	ASIS="$(ASIS)" EXEEXT="$(EXEEXT)" LDAP="$(LDAP)" DEBUG="$(DEBUG)" \
	RM="$(RM)" CP="$(CP)" MKDIR="$(MKDIR)" SED="$(SED)" GCC="$(GCC)" \
	GPRBUILD="$(GPRBUILD)" ZLIB="$(ZLIB)" BDIR="$(BDIR)" \
	prefix="$(prefix)" ENABLE_SHARED="$(ENABLE_SHARED)" \
	SOEXT="$(SOEXT)" GNAT="$(GNAT)" \
	T2A="../../$(BDIR)/static/tools/templates2ada" \
	LIBRARY_TYPE="$(LIBRARY_TYPE)" PYTHON="$(PYTHON)" \
	TARGET="$(TARGET)" IS_CROSS=$(IS_CROSS) GPRINSTALL="$(GPRINSTALL)"

build-doc:
	echo ""
	echo "=== Build doc"
	${MAKE} -C docs html latexpdf
	${MAKE} -C templates_parser/docs html latexpdf

run_regtests:
	echo ""
	echo "=== Run regression tests"
	echo ""
	$(MAKE) -C regtests aws_regtests $(ALL_OPTIONS)

force:

#############################################################################
#  Configuration for GNAT Projet Files

MODULES = config include ssl src gps regtests demos

MODULES_SETUP = ${MODULES:%=%_setup} templates_parser_setup

MODULES_INSTALL = ${MODULES:%=%_install}

MODULES_CHECK = ${MODULES:%=%_check}

#  XML/Ada

ifeq (${XMLADA}, true)
PRJ_XMLADA=Installed
GEXT_MODULE := gxmlada_setup
else
PRJ_XMLADA=Disabled
GEXT_MODULE := gxmlada_dummy
endif

ifndef TP_XMLADA
TP_XMLADA=$(PRJ_XMLADA)
endif

#  Ldap

ifeq (${LDAP}, true)
PRJ_LDAP=Installed
else
PRJ_LDAP=Disabled
endif

#  ASIS

ifeq (${ASIS}, true)
PRJ_ASIS=Installed
GEXT_MODULE := $(GEXT_MODULE) gasis_setup
else
PRJ_ASIS=Disabled
GEXT_MODULE := $(GEXT_MODULE) gasis_dummy
endif

#  Sockets

ifeq ($(IPv6), true)
PRJ_SOCKLIB=IPv6
else
PRJ_SOCKLIB=GNAT
endif

#  Debug

ifeq ($(DEBUG), true)
PRJ_BUILD=Debug
else
PRJ_BUILD=Release
endif

ifeq ($(IS_CROSS), true)
TPREFIX=$(DESTDIR)$(prefix)/$(TARGET)
else
TPREFIX=$(DESTDIR)$(prefix)
endif

#  Install directories

I_INC	= $(TPREFIX)/include/aws

GALL_OPTIONS := $(ALL_OPTIONS) \
	PRJ_BUILD="$(PRJ_BUILD)" \
	PRJ_XMLADA="$(PRJ_XMLADA)" \
	PRJ_ASIS="$(PRJ_ASIS)" \
	PRJ_SOCKLIB="$(PRJ_SOCKLIB)" \
	PRJ_LDAP="$(PRJ_LDAP)" \
	PRJ_TARGET="$(PRJ_TARGET)" \
	TP_XMLADA="$(TP_XMLADA)" \
	I_INC="$(I_INC)"

${MODULES_SETUP}: force
	${MAKE} -C ${@:%_setup=%} setup $(GALL_OPTIONS)

${MODULES_INSTALL}: force
	${MAKE} -C ${@:%_install=%} install $(GALL_OPTIONS)

${MODULES_CHECK}: force
	${MAKE} -C ${@:%_check=%} check $(GALL_OPTIONS)

GPROPTS = -XPRJ_BUILD=$(PRJ_BUILD) -XPRJ_SOCKLIB=$(PRJ_SOCKLIB) \
		-XPRJ_ASIS=$(PRJ_ASIS) -XPRJ_LDAP=$(PRJ_LDAP) \
		-XPRJ_XMLADA=$(PRJ_XMLADA) -XTARGET=$(TARGET) \
		-XPROCESSORS=$(PROCESSORS) -XSOCKET=$(SOCKET) \
		-XPRJ_TARGET=$(PRJ_TARGET)

GPR_STATIC = -XLIBRARY_TYPE=static -XXMLADA_BUILD=static
GPR_SHARED = -XLIBRARY_TYPE=relocatable -XXMLADA_BUILD=relocatable
GPR_OTHER  = -XLIBRARY_TYPE=$(OTHER_LIBRARY_TYPE) \
		-XXMLADA_BUILD=$(OTHER_LIBRARY_TYPE)

#######################################################################
#  build

build-native:
	$(GPRBUILD) -p $(GPROPTS) $(GPR_STATIC) tools/tools.gpr
ifeq (${ENABLE_SHARED}, true)
	$(GPRBUILD) -p $(GPROPTS) $(GPR_SHARED) aws.gpr
endif
	$(GPRBUILD) -p $(GPROPTS) $(GPR_STATIC) gps/gps_support.gpr
	${MAKE} -C gps $(GALL_OPTIONS) after-build

build-cross:
	$(GPRBUILD) -p --target=$(TARGET) $(GPROPTS) \
		$(GPR_STATIC) tools/tools.gpr
ifeq (${ENABLE_SHARED}, true)
	$(GPRBUILD) -p --target=$(TARGET) $(GPROPTS) \
		$(GPR_SHARED) aws.gpr
endif

ifeq (${IS_CROSS}, true)
build: build-cross
else
build: build-native
endif

#######################################################################
#  clean

clean-native:
	-$(GPRCLEAN) $(GPROPTS) $(GPR_STATIC) tools/tools.gpr
ifeq (${ENABLE_SHARED}, true)
	-$(GPRCLEAN) $(GPROPTS) $(GPR_SHARED) aws.gpr
endif
	-$(GPRCLEAN) $(GPROPTS) $(GPR_STATIC) gps/gps_support.gpr

clean-cross:
	-$(GPRCLEAN) $(GPROPTS) --target=$(TARGET) $(GPR_STATIC) aws.gpr
ifeq (${ENABLE_SHARED}, true)
	-$(GPRCLEAN) $(GPROPTS) --target=$(TARGET) $(GPR_SHARED) aws.gpr
endif

ifeq (${IS_CROSS}, true)
clean: clean-cross
else
clean: clean-native
endif
	-${MAKE} -C regtests $(GALL_OPTIONS) clean
	-${MAKE} -C docs $(GALL_OPTIONS) clean
	-${RM} -fr $(BROOTDIR)
	-${RM} -f makefile.setup

#######################################################################
#  install

install-clean:
ifneq (,$(wildcard $(TPREFIX)/share/gpr/manifests/aws))
	-$(GPRINSTALL) $(GPROPTS) --uninstall --prefix=$(TPREFIX) aws
endif

install-native: install-clean
	$(GPRINSTALL) $(GPROPTS) -p -f --prefix=$(TPREFIX) \
		-XLIBRARY_TYPE=$(DEFAULT_LIBRARY_TYPE) aws.gpr
	$(GPRINSTALL) $(GPROPTS) -p -f --prefix=$(TPREFIX) \
		$(GPR_STATIC) --mode=usage \
		--install-name=aws tools/tools.gpr
ifeq (${ENABLE_SHARED}, true)
	$(GPRINSTALL) $(GPROPTS) -p -f --prefix=$(TPREFIX) \
		$(GPR_OTHER) --build-name=$(OTHER_LIBRARY_TYPE) aws.gpr
endif

install-cross: install-clean
	$(GPRINSTALL) $(GPROPTS) -p -f --prefix=$(TPREFIX) \
		--target=$(TARGET) \
		-XLIBRARY_TYPE=$(DEFAULT_LIBRARY_TYPE) aws.gpr
	$(GPRINSTALL) $(GPROPTS) -p -f --prefix=$(TPREFIX) --mode=usage \
		--target=$(TARGET) $(GPROPTS) \
		--install-name=aws tools/tools.gpr
ifeq (${ENABLE_SHARED}, true)
	$(GPRINSTALL) $(GPROPTS) -p -f --prefix=$(TPREFIX) \
		--target=$(TARGET) $(GPR_OTHER) \
		--build-name=$(OTHER_LIBRARY_TYPE) aws.gpr
endif

ifeq (${IS_CROSS}, true)
install: install-cross
else
install: install-native
endif

#######################################################################

check: $(MODULES_CHECK)

PRJDIR = $(BROOTDIR)/projects

gasis_dummy:
	echo "abstract project AWS_ASIS is" > $(PRJDIR)/aws_asis.gpr;
	echo "   for Source_Dirs use ();" >> $(PRJDIR)/aws_asis.gpr;
	echo "end AWS_ASIS;" >> $(PRJDIR)/aws_asis.gpr;

gasis_setup:
	echo 'with "asis";' > $(PRJDIR)/aws_asis.gpr
	echo "abstract project AWS_ASIS is" >> $(PRJDIR)/aws_asis.gpr
	echo "   for Source_Dirs use ();" >> $(PRJDIR)/aws_asis.gpr
	echo "end AWS_ASIS;" >> $(PRJDIR)/aws_asis.gpr

gxmlada_dummy:
	echo "abstract project AWS_XMLADA is" > $(PRJDIR)/aws_xmlada.gpr
	echo "   for Source_Dirs use ();" >> $(PRJDIR)/aws_xmlada.gpr
	echo "end AWS_XMLADA;" >> $(PRJDIR)/aws_xmlada.gpr

gxmlada_setup:
	echo 'with "xmlada";' > $(PRJDIR)/aws_xmlada.gpr
	echo "abstract project AWS_XMLADA is" >> $(PRJDIR)/aws_xmlada.gpr
	echo "   for Source_Dirs use ();" >> $(PRJDIR)/aws_xmlada.gpr
	echo "end AWS_XMLADA;" >> $(PRJDIR)/aws_xmlada.gpr

setup_dir:
	-$(MKDIR) $(PRJDIR)

CONFGPR	= $(PRJDIR)/aws_config.gpr

ifeq (${SOCKET}, ssl)
SOCKET = openssl
endif

SSL_SUFFIX=$(SOCKET)

ifeq (${SOCKET}, std)
SSL_SUFFIX = dummy
endif

setup_config:
	echo 'abstract project AWS_Config is' > $(CONFGPR)
	echo '   for Source_Dirs use ();' >> $(CONFGPR)
	echo >> $(CONFGPR)
	echo '   type Boolean_Type is ("true", "false");' >> $(CONFGPR)
	echo '   Zlib_Exists : Boolean_Type := "$(ZLIB)";' >> $(CONFGPR)
	echo >> $(CONFGPR)
	echo '   type SOCKET_Type is ("std", "openssl", "gnutls");' \
	  >> $(CONFGPR)
	echo '   SOCKET : SOCKET_Type := "$(SOCKET)";' >> $(CONFGPR)
	echo >> $(CONFGPR)
	echo 'end AWS_Config;' >> $(CONFGPR)

#  Set up all modules to create all the directories. This way it is possible
#  to build AWS using GPS using any settings.

setup_modules: $(MODULES_SETUP)

gen_setup:
	echo "prefix=$(prefix)" > makefile.setup
	echo "DEFAULT_LIBRARY_TYPE=$(DEFAULT_LIBRARY_TYPE)" >> makefile.setup
	echo "ENABLE_SHARED=$(ENABLE_SHARED)" >> makefile.setup
	echo "ZLIB=$(ZLIB)" >> makefile.setup
	echo "XMLADA=$(XMLADA)" >> makefile.setup
	echo "ASIS=$(ASIS)" >> makefile.setup
	echo "IPv6=$(IPv6)" >> makefile.setup
	echo "SOCKET=$(SOCKET)" >> makefile.setup
	echo "LDAP=$(LDAP)" >> makefile.setup
	echo "DEBUG=$(DEBUG)" >> makefile.setup
	echo "PROCESSORS=$(PROCESSORS)" >> makefile.setup
	echo "TARGET=$(TARGET)" >> makefile.setup
	echo "GSOAP=false" >> makefile.setup

setup: gen_setup setup_dir setup_modules setup_config setup_tp $(GEXT_MODULE)

setup_tp:
	$(MAKE) -C templates_parser setup $(GALL_OPTIONS)

=== gps/Makefile ===
############################################################################
#                              Ada Web Server                              #
#                                                                          #
#                     Copyright (C) 2003-2015, AdaCore                     #
#                                                                          #
#  This is free software;  you can redistribute it  and/or modify it       #
#  under terms of the  GNU General Public License as published  by the     #
#  Free Software  Foundation;  either version 3,  or (at your option) any  #
#  later version.  This software is distributed in the hope  that it will  #
#  be useful, but WITHOUT ANY WARRANTY;  without even the implied warranty #
#  of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU     #
#  General Public License for  more details.                               #
#                                                                          #
#  You should have  received  a copy of the GNU General  Public  License   #
#  distributed  with  this  software;   see  file COPYING3.  If not, go    #
#  to http://www.gnu.org/licenses for a complete copy of the license.      #
############################################################################

.SILENT:

ALL_API = $(sort $(shell ls ../src/core/*.ads ../src/extended/*.ads \
	../src/soap/*.ads  ../src/xsrc/*.ads \
	../templates_parser/src/*.ads ../templates_parser/xsrc/*.ads))

setup:

install:

check:

after-build:
	../$(BDIR)/../../$(TARGET)/common/bin/gen_gps_ref $(ALL_API)

clean:
	-$(RM) -f *~ aws_api.xml

=== ssl/Makefile ===
############################################################################
#                              Ada Web Server                              #
#                                                                          #
#                     Copyright (C) 2003-2015, AdaCore                     #
#                                                                          #
#  This is free software;  you can redistribute it  and/or modify it       #
#  under terms of the  GNU General Public License as published  by the     #
#  Free Software  Foundation;  either version 3,  or (at your option) any  #
#  later version.  This software is distributed in the hope  that it will  #
#  be useful, but WITHOUT ANY WARRANTY;  without even the implied warranty #
#  of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU     #
#  General Public License for  more details.                               #
#                                                                          #
#  You should have  received  a copy of the GNU General  Public  License   #
#  distributed  with  this  software;   see  file COPYING3.  If not, go    #
#  to http://www.gnu.org/licenses for a complete copy of the license.      #
############################################################################

.SILENT:

check:
	$(GNAT) check -Pssl -rules -from=../aws.checks

setup:

install:

=== demos/autobahn/Makefile ===
############################################################################
#                              Ada Web Server                              #
#                                                                          #
#                    Copyright (C) 2013-2015, AdaCore                      #
#                                                                          #
#  This is free software;  you can redistribute it  and/or modify it       #
#  under terms of the  GNU General Public License as published  by the     #
#  Free Software  Foundation;  either version 3,  or (at your option) any  #
#  later version.  This software is distributed in the hope  that it will  #
#  be useful, but WITHOUT ANY WARRANTY;  without even the implied warranty #
#  of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU     #
#  General Public License for  more details.                               #
#                                                                          #
#  You should have  received  a copy of the GNU General  Public  License   #
#  distributed  with  this  software;   see  file COPYING3.  If not, go    #
#  to http://www.gnu.org/licenses for a complete copy of the license.      #
############################################################################

all:
	gprbuild -p autobahn.gpr

clean:
	gprclean autobahn.gpr

=== demos/hello_wsdl/Makefile ===
############################################################################
#                              Ada Web Server                              #
#                                                                          #
#                     Copyright (C) 2010-2015, AdaCore                     #
#                                                                          #
#  This is free software;  you can redistribute it  and/or modify it       #
#  under terms of the  GNU General Public License as published  by the     #
#  Free Software  Foundation;  either version 3,  or (at your option) any  #
#  later version.  This software is distributed in the hope  that it will  #
#  be useful, but WITHOUT ANY WARRANTY;  without even the implied warranty #
#  of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU     #
#  General Public License for  more details.                               #
#                                                                          #
#  You should have  received  a copy of the GNU General  Public  License   #
#  distributed  with  this  software;   see  file COPYING3.  If not, go    #
#  to http://www.gnu.org/licenses for a complete copy of the license.      #
############################################################################

-include ../../makefile.setup

ifneq (${XMLADA},false)
all: build_wsdl
	gprbuild hello_wsdl.gpr
else
all:
endif

build_wsdl:
	echo Generate stub/skel from WSDL documents
	wsdl2aws -q -f -doc -timeouts 1,2,2 hello.wsdl

clean:
	gprclean hello_wsdl.gpr
	rm -f hello_demo*

=== demos/hotplug/Makefile ===
############################################################################
#                              Ada Web Server                              #
#                                                                          #
#                     Copyright (C) 2010-2015, AdaCore                     #
#                                                                          #
#  This is free software;  you can redistribute it  and/or modify it       #
#  under terms of the  GNU General Public License as published  by the     #
#  Free Software  Foundation;  either version 3,  or (at your option) any  #
#  later version.  This software is distributed in the hope  that it will  #
#  be useful, but WITHOUT ANY WARRANTY;  without even the implied warranty #
#  of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU     #
#  General Public License for  more details.                               #
#                                                                          #
#  You should have  received  a copy of the GNU General  Public  License   #
#  distributed  with  this  software;   see  file COPYING3.  If not, go    #
#  to http://www.gnu.org/licenses for a complete copy of the license.      #
############################################################################

all:
	gprbuild hotplug.gpr

clean:
	gprclean hotplug.gpr

=== demos/runme/Makefile ===
############################################################################
#                              Ada Web Server                              #
#                                                                          #
#                     Copyright (C) 2010-2015, AdaCore                     #
#                                                                          #
#  This is free software;  you can redistribute it  and/or modify it       #
#  under terms of the  GNU General Public License as published  by the     #
#  Free Software  Foundation;  either version 3,  or (at your option) any  #
#  later version.  This software is distributed in the hope  that it will  #
#  be useful, but WITHOUT ANY WARRANTY;  without even the implied warranty #
#  of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU     #
#  General Public License for  more details.                               #
#                                                                          #
#  You should have  received  a copy of the GNU General  Public  License   #
#  distributed  with  this  software;   see  file COPYING3.  If not, go    #
#  to http://www.gnu.org/licenses for a complete copy of the license.      #
############################################################################

-include ../../makefile.setup

ifneq (${SOCKET},std)
all:
	gprbuild runme.gpr
else
all:
endif

clean:
	gprclean runme.gpr

=== demos/split/Makefile ===
############################################################################
#                              Ada Web Server                              #
#                                                                          #
#                     Copyright (C) 2010-2015, AdaCore                     #
#                                                                          #
#  This is free software;  you can redistribute it  and/or modify it       #
#  under terms of the  GNU General Public License as published  by the     #
#  Free Software  Foundation;  either version 3,  or (at your option) any  #
#  later version.  This software is distributed in the hope  that it will  #
#  be useful, but WITHOUT ANY WARRANTY;  without even the implied warranty #
#  of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU     #
#  General Public License for  more details.                               #
#                                                                          #
#  You should have  received  a copy of the GNU General  Public  License   #
#  distributed  with  this  software;   see  file COPYING3.  If not, go    #
#  to http://www.gnu.org/licenses for a complete copy of the license.      #
############################################################################

all:
	gprbuild split.gpr

clean:
	gprclean split.gpr

=== demos/test_ldap/Makefile ===
############################################################################
#                              Ada Web Server                              #
#                                                                          #
#                     Copyright (C) 2010-2015, AdaCore                     #
#                                                                          #
#  This is free software;  you can redistribute it  and/or modify it       #
#  under terms of the  GNU General Public License as published  by the     #
#  Free Software  Foundation;  either version 3,  or (at your option) any  #
#  later version.  This software is distributed in the hope  that it will  #
#  be useful, but WITHOUT ANY WARRANTY;  without even the implied warranty #
#  of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU     #
#  General Public License for  more details.                               #
#                                                                          #
#  You should have  received  a copy of the GNU General  Public  License   #
#  distributed  with  this  software;   see  file COPYING3.  If not, go    #
#  to http://www.gnu.org/licenses for a complete copy of the license.      #
############################################################################

-include ../../makefile.setup

ifneq (${LDAP},false)
all:
	gprbuild test_ldap.gpr
else
all:
endif

clean:
	gprclean test_ldap.gpr

=== demos/test_mail/Makefile ===
############################################################################
#                              Ada Web Server                              #
#                                                                          #
#                     Copyright (C) 2010-2015, AdaCore                     #
#                                                                          #
#  This is free software;  you can redistribute it  and/or modify it       #
#  under terms of the  GNU General Public License as published  by the     #
#  Free Software  Foundation;  either version 3,  or (at your option) any  #
#  later version.  This software is distributed in the hope  that it will  #
#  be useful, but WITHOUT ANY WARRANTY;  without even the implied warranty #
#  of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU     #
#  General Public License for  more details.                               #
#                                                                          #
#  You should have  received  a copy of the GNU General  Public  License   #
#  distributed  with  this  software;   see  file COPYING3.  If not, go    #
#  to http://www.gnu.org/licenses for a complete copy of the license.      #
############################################################################

all:
	gprbuild test_mail.gpr

clean:
	gprclean test_mail.gpr

=== demos/websockets/Makefile ===
############################################################################
#                              Ada Web Server                              #
#                                                                          #
#                    Copyright (C) 2012-2015, AdaCore                      #
#                                                                          #
#  This is free software;  you can redistribute it  and/or modify it       #
#  under terms of the  GNU General Public License as published  by the     #
#  Free Software  Foundation;  either version 3,  or (at your option) any  #
#  later version.  This software is distributed in the hope  that it will  #
#  be useful, but WITHOUT ANY WARRANTY;  without even the implied warranty #
#  of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU     #
#  General Public License for  more details.                               #
#                                                                          #
#  You should have  received  a copy of the GNU General  Public  License   #
#  distributed  with  this  software;   see  file COPYING3.  If not, go    #
#  to http://www.gnu.org/licenses for a complete copy of the license.      #
############################################################################

all:
	gprbuild websock.gpr

clean:
	gprclean websock.gpr

=== demos/ws/Makefile ===
############################################################################
#                              Ada Web Server                              #
#                                                                          #
#                     Copyright (C) 2010-2015, AdaCore                     #
#                                                                          #
#  This is free software;  you can redistribute it  and/or modify it       #
#  under terms of the  GNU General Public License as published  by the     #
#  Free Software  Foundation;  either version 3,  or (at your option) any  #
#  later version.  This software is distributed in the hope  that it will  #
#  be useful, but WITHOUT ANY WARRANTY;  without even the implied warranty #
#  of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU     #
#  General Public License for  more details.                               #
#                                                                          #
#  You should have  received  a copy of the GNU General  Public  License   #
#  distributed  with  this  software;   see  file COPYING3.  If not, go    #
#  to http://www.gnu.org/licenses for a complete copy of the license.      #
############################################################################

all:
	gprbuild ws.gpr

clean:
	gprclean ws.gpr

=== debian/changelog ===
libaws (17.2.2017-2) unstable; urgency=medium

  * Build-Depend latexmk for LaTeX sphinx-doc module. Closes: #876741.
  * Rebuild with xmlada 17.1.2017-5 and templates-parse 17.2-3.
    -dev version is already new in testing.
  * Increase gprbuild verbosity in run-time test.
  * Build-Depend: python3 version of sphinx-doc.
  * Standards-Version: 4.1.0.

 -- Nicolas Boulenguez <nicolas@debian.org>  Tue, 26 Sep 2017 14:08:30 +0200

libaws (17.2.2017-1) unstable; urgency=medium

  * Upload to unstable.
  * New upstream release. Build with gnat-7.
    Bump soversion in runtime package name.
    -dev already has a different name than in unstable.
    -dev now Break/Replace: previous -dev via gnat, gnat-7.
  * Let watch file target (debian redirector to) libre.adacore.com.
    The license there is pure GPL-3+.
  * Depend: libjs-scriptaculous and prototype instead of embedding copies.
  * Disable sphinxdoc parallelism to work around #869098.
  * Reduce number of gprbuild runs: let tools.gpr build the shared library.
  * Add forgotten CPPFLAGS.
  * Debhelper 10. Drop explicit targets confusing dh.
  * Standards-Version: 4.0.1. Allow DEB_BUILD_OPTIONS=nodoc.
    Priority: optional. Only Suggest: -doc. HTTPS copyright format URL.
  * Drop explicit gprbuild configuration, Build-Depend: gprbuild >= 2017.
  * Gcc-7 now handles SOURCE_DATE_EPOCH directly.
  * PDFLaTeX now handles SOURCE_DATE_EPOCH without faketime.
  * Allow -doc package to satisfy multi-arch foreign dependencies.
  * Update texlive-generic package name, Vcs-Mtn URL.
  * Deduplicate manually (symlinks confused by pbuilder /build->/tmp/build).

 -- Nicolas Boulenguez <nicolas@debian.org>  Sat, 12 Aug 2017 15:45:20 +0200

libaws (3.3.2-3) experimental; urgency=medium

  * Rebuild against libxmlada7-dev and libtemplates-parser11.10.2-dev.
    Rename -dev package, Break/Replace previous versions per Ada policy.
  * gprbuild now overrides pie build flags by itself for shared libraries.
  * Drop package-contains-timestamped-gzip lintian override, issue is fixed
    as a side-effect by dh_stripnondeterminism.

 -- Nicolas Boulenguez <nicolas@debian.org>  Tue, 16 Aug 2016 14:55:50 +0200

=== debian/control ===
Source: libaws
Priority: optional
Section: libs
Maintainer: Ludovic Brenta <lbrenta@debian.org>
Uploaders: Nicolas Boulenguez <nicolas@debian.org>
Build-Depends: dpkg-dev (>= 1.16.1), debhelper (>= 10),
 gnat, gnat-7,
# This line is parsed by debian/rules to set GNAT_VERSION.
 dh-ada-library (>= 6.7),
# dh-ada-library 6.7 knows that -dbg packages are optional
 gprbuild (>= 2017),
# gprbuild removing auto.cgpr after the build.
# for build_aws.gpr:
 libgnutls28-dev,
# This line, if present, is parsed by debian/rules to set SSL.
 libldap2-dev,
 libtemplates-parser11.10.2-dev (>= 17.2-3),
 libxmlada-unicode7-dev (>= 17.1.2017-5),
 libxmlada-input7-dev (>= 17.1.2017-5),
 libxmlada-sax7-dev (>= 17.1.2017-5),
 libxmlada-dom7-dev (>= 17.1.2017-5),
 libxmlada-schema7-dev (>= 17.1.2017-5),
 libz-dev,
 pkg-config,
# for ada2wsdl.gpr:
 libasis2017-dev
Build-Depends-Indep: texinfo,
 python3-sphinx,
 sphinx-common,
 latexmk,
# sphinx >= 1.6 requires the latexmk driver.
 texlive-fonts-recommended,
# sphinx-doc requires iftex.sty:
 texlive-plain-generic,
 texlive-latex-extra
Standards-Version: 4.1.0
Vcs-Browser: http://www.ada-france.org:8081/branch/changes/org.debian.libaws
Vcs-Mtn: mtn://www.ada-france.org?org.debian.libaws
Homepage: https://libre.adacore.com/libre

Package: libaws3.3.2.2-dev
Section: libdevel
Architecture: any
Depends: ${misc:Depends},
 libgnutls28-dev,
 libldap2-dev,
 libz-dev,
 ${ada:Depends}
Recommends: libaws-bin (= ${binary:Version})
Suggests: libaws-doc (= ${source:Version}),
 libjs-scriptaculous,
 libjs-prototype
Description: Ada Web Server development files
 AWS is a complete framework to develop Web based applications. The
 main part of the framework is the embedded Web server. This small yet
 powerful Web server can be embedded into your application so your
 application will be able to talk with a Web browser. Around this Web
 server a lot of services have been developed.
 .
  - A Web parameters module. This module takes care of retrieving the
    forms or URL parameters and to build an associative table for easy
    access.
  - A session server, this is a very important module to be able to
    keep client's data from page to page.
  - Support SOAP to develop Web Services.
  - A tool to generate Web Services stubs/skeletons from a WSDL
    document.
  - A template parser, this module makes it possible to completely
    separate the Web design from the code. No more scripting into your Web
    page.
  - Support for Secure Sockets (HTTPS/SSL), this is based on the GNU TLS
    library.
  - Support for large servers using dispatchers based on URI, request
    methods.
  - Support for virtual hosting (dispatchers based on the host name).
  - Support for server push.
  - A directory browser ready to be used in any application.
  - A status page to get many information about the current AWS server.
  - A log module. Log files keep information about all resources
    requested to the server.
  - Hotplug modules which can be loaded/unloaded dynamically to add
    specific features to a server.
  - A communication API to exchange data between applications using the
    HTTP protocol.
  - A configuration API to tune/change the server parameters without
    recompilation.
  - A client API to retrieve any Web page from a Web site.
  - A Web Page service to build a simple static page server.
  - Support for SMTP, LDAP and Jabber protocols.

Package: libaws-bin
Section: devel
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Ada Web Server utilities
 AWS is a complete framework to develop Web based applications. The
 main part of the framework is the embedded Web server. This small yet
 powerful Web server can be embedded into your application so your
 application will be able to talk with a Web browser. Around this Web
 server a lot of services have been developed.
 .
 This package contains utility programs to help develop web applications
 with AWS:
 .
 awsres transforms any text or binary file into an Ada unit which you
 can compile into your application, thereby making your application
 completely independent of any external files (think: embedded)
 .
 ada2wsdl, an ASIS program, reads Ada unit specifications and creates
 descriptions in the Web Service Description Language, so that you can
 advertise your web service application to the world.
 .
 wsdl2aws does the opposite job: it creates an Ada unit (spec and
 skeleton body) conforming to a specified description in WSDL.

Package: libaws17.2.2017
Architecture: any
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends}
Multi-Arch: same
Description: Ada Web Server shared library
 AWS is a complete framework to develop Web based applications. The
 main part of the framework is the embedded Web server. This small yet
 powerful Web server can be embedded into your application so your
 application will be able to talk with a Web browser. Around this Web
 server a lot of services have been developed.
 .
 This is the runtime library for the Ada Web Server.

Package: libaws-doc
Section: doc
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}, ${sphinxdoc:Depends}
Suggests: gnat
Description: Ada Web Server documentation
 AWS is a complete framework to develop Web based applications. The
 main part of the framework is the embedded Web server. This small yet
 powerful Web server can be embedded into your application so your
 application will be able to talk with a Web browser. Around this Web
 server a lot of services have been developed.
 .
 This package contains the documentation for the Ada Web Server in
 info, ASCII and HTML formats, as well as demos and source code of
 reusable web elements.

=== debian/rules ===
#!/usr/bin/make -f
# Build script for Ada Web Server in Debian.
# Copyright (c) 2003-2013 Ludovic Brenta <lbrenta@debian.org>
# Copyright (c) 2014-2017 Nicolas Boulenguez <nicolas@debian.org>

# This build script is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License as
# published by the Free Software Foundation; either version 3 of the
# License, or (at your option) any later version.

# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.

# You should have received a copy of the GNU General Public License
# along with this program; if not, see <http://www.gnu.org/licenses/>.

# On Debian systems, the full text of the GPL is in the file
# /usr/share/common-licenses/GPL-3.

$(foreach line,$(shell sed -n '\
  s/^ gnat, gnat-\([0-9.]\+\),$$/ \
    GNAT_VERSION:=\1 \
  /p;\
  s/^Package: libaws\([0-9.]\+\)$$/ \
    soname:=libaws.so.\1 \
  /p;\
  s/^ libgnutls[0-9.]*-dev,$$/ \
    SSL:=gnutls \
  /p;\
  s/^ libssl-dev,$$/ \
    SSL:=openssl \
  /p;\
  ' debian/control),$(eval $(line)))

DEB_BUILD_MAINT_OPTIONS := hardening=+all
include /usr/share/dpkg/default.mk
include /usr/share/ada/debian_packaging-$(GNAT_VERSION).mk

ADAFLAGS += -gnatafno -gnatVa -gnatwa
CFLAGS += `pkg-config --cflags $(filter-out dummy,$(SSL)) zlib`
LDLIBS := `pkg-config --libs   $(filter-out dummy,$(SSL)) zlib` -llber -lldap

# Circumvent #760211. Since LDFLAGS contains --as-needed, this setting
# only takes effect on architectures triggering the bug.
LDLIBS += -lpthread

######################################################################
%:
	dh $@ --with ada-library

# Ignore upstream makefile (and ./configure, if ever).
.PHONY: $(addprefix override_dh_auto_,configure build-arch build-indep test install clean)
# Configure test install exist and are empty so that dh_auto_* does
# nothing.  We will replace upstream makefiles with build-* and clean.

######################################################################
# See comments in aws-os_lib-tmplt.c.
build-aws-dynamic build-aws-static: src/core/aws-os_lib.ads
# Tell Make that the source must be created but never updated, even if
# its timestamp is tricked later for deterministic ALI files.
src/core/aws-os_lib.ads:|src/core/xoscons \
                         src/core/aws-os_lib-tmplt.i \
                         src/core/aws-os_lib-tmplt.s
	cd src/core && ./xoscons aws-os_lib
src/core/xoscons: config/setup/xoscons.adb
	gnatmake $(BUILDER_OPTIONS) $< -D src/core -o $@ -cargs $(ADAFLAGS) -largs $(LDFLAGS)
src/core/aws-os_lib-tmplt.s: %.s: %.i
	$(CC) -S $(CFLAGS) $< -o $@
src/core/aws-os_lib-tmplt.i: config/setup/aws-os_lib-tmplt.c
	$(CC) -C -E $(CPPFLAGS) -DTARGET=\"$(DEB_HOST_MULTIARCH)\" $< -o $@

override_dh_auto_clean::
	rm -f src/core/aws-os_lib* src/core/xoscons* src/core/xutil.*

######################################################################
# Build both versions of the library.

override_dh_auto_build-arch: build-aws-static build-tools
.PHONY: build-aws-dynamic build-tools
build-aws-static:
	gprbuild -p $(BUILDER_OPTIONS) debian/build_aws.gpr \
	  $(foreach v,ADAFLAGS CFLAGS CPPFLAGS SSL,"-X$(v)=$($(v))")
build-tools:
	gprbuild -p $(BUILDER_OPTIONS) debian/tools.gpr \
	  $(foreach v,ADAFLAGS CFLAGS CPPFLAGS LDFLAGS LDLIBS soname SSL,"-X$(v)=$($(v))")
override_dh_auto_clean::
	rm -fr $(foreach d,lib obj,$(foreach k,dynamic static, \
          debian/build_aws_$(d)_$(k))) debian/tools_obj debian/tools_exe

# An override is necessary because LDLIBS contains a shell escape.
# The projet should import directly xmlada.gpr and
# templates-parser.gpr (both are used by specs).
.PHONY: override_dh_ada_library-arch
override_dh_ada_library-arch:
	dh_ada_library \
          $(foreach v,LDLIBS soname SSL,"$(v)=$($(v))") \
          debian/build_aws.gpr

######################################################################
.PHONY: override_dh_compress
override_dh_compress:
	dh_compress --package=libaws-doc -X.adb -X.ads -X.thtml -X.wsdl
	dh_compress --remaining-packages

INSTALLED_EXAMPLES := debian/libaws-doc/usr/share/doc/libaws-doc/examples
check_link = \
  diff -q debian/libaws-doc/usr/share/doc/libaws-doc/examples/$(1) \
          debian/libaws-doc/usr/share/doc/libaws-doc/examples/$(2) \
  && dh_link -plibaws-doc   usr/share/doc/libaws-doc/examples/$(1) \
                            usr/share/doc/libaws-doc/examples/$(2)
.PHONY: override_dh_installexamples-indep
override_dh_installexamples-indep:
	dh_installexamples --indep
 # Fix permissions.
	find $(INSTALLED_EXAMPLES) -type f -print0 | xargs -0r chmod 644
 # Replace duplicate files with symlinks.
 # (rdfind and symlinks are confused on pbuilder with /build->/tmp/build)
 # lintian detects things to add, diff detects thing to remove.
	$(call check_link,runme/adains.png,res_demo/adains.png)
	$(call check_link,runme/cert.pem,agent/cert.pem)
	$(call check_link,soap_disp/soap_client.adb,soap_demo/soap_client.adb)
	$(call check_link,upload/aws.ini,https/aws.ini)
	$(call check_link,web_block_ajax_templates/r_widget_counter.txml,web_block_ajax/r_widget_counter.txml)
	$(call check_link,web_block_ajax_templates/web_callbacks.ads,web_block_ajax/web_callbacks.ads)
	$(call check_link,ws/page1.html,web_elements/page1.html)
	$(call check_link,ws/ws.ini,wps/wps.ini)

######################################################################
# Documentation.
# ./makefile would recompute all makefile.conf variables, assume only
# HTML output format, and assume the existence of templates_parser/.
# TODO: append SPHINXOPTS=-j$(BUILDER_JOBS) once #869098 is fixed.
override_dh_auto_build-indep:
ifeq (,$(filter nodoc,$(DEB_BUILD_OPTIONS)))
	$(MAKE) -C docs html info latexpdf text style-guide.pdf \
          $(foreach v,ADAFLAGS LDFLAGS,"$(v)=$($(v))")
endif
override_dh_auto_clean::
	$(MAKE) -C docs clean
	rm -f docs/source/*.pyc docs/source/confvars.py
	rm -fr docs/source/__pycache__

######################################################################
# Mimic 'dh --with sphinxdoc', but without adding sphinx-common to
# Build-Depends for arch-only builds.
.PHONY: override_dh_installdocs-indep
override_dh_installdocs-indep:
	dh_installdocs -i
	dh_sphinxdoc

=== debian/tests/control ===
Tests: ada2wsdl
Depends: libaws-bin

Tests: hello-wsdl, link-with-shared
Depends: @, gprbuild

=== debian/watch ===
# See README.source.

version=4
opts=\
  repack,\
  compression=xz,\
  dversionmangle=s/.*\.//,\
  filenamemangle=s/^.*download=// \
https://qa.debian.org/cgi-bin/fakeupstream.cgi?upstream=adacore/aws \
.*aws-gpl@ANY_VERSION@-src@ARCHIVE_EXT@
